//
//  BBViewController.m
//  BouncingBall
//
//  Created by Sonny Fazio on 3/5/12.
//  Copyright (c) 2012 SonsterMedia. All rights reserved.
//

#import "BBViewController.h"
@interface BBViewController ()

@end

@implementation BBViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	bouncingBall = [[UIView alloc]initWithFrame:CGRectMake(0, 0, 40, 40)];
	[bouncingBall setBackgroundColor:[UIColor redColor]];
	[bouncingBall.layer setMasksToBounds:YES];
	[bouncingBall.layer setCornerRadius:20];
	[self.view addSubview:bouncingBall];
	[self bounceDownStepWithStartingPoint:CGPointMake(0, 0) andEndPoint:CGPointMake(30, 60)];
}




-(void)bounceDownStepWithStartingPoint:(CGPoint)startPoint andEndPoint:(CGPoint)endPoint
{
	endPosition = endPoint;
	CAKeyframeAnimation *bounce = [CAKeyframeAnimation animationWithKeyPath:@"position"];
	bounce.delegate = self;
	bounce.fillMode = kCAFillModeForwards;
	bounce.removedOnCompletion = NO;
	CGMutablePathRef path = CGPathCreateMutable();
	CGPathMoveToPoint(path, NULL, startPoint.x, startPoint.y);
	CGPathAddCurveToPoint(path, NULL, endPoint.x, startPoint.y, endPoint.x, startPoint.y, endPoint.x, endPoint.y);
	bounce.path = path;
	CGPathRelease(path);
	[bouncingBall.layer addAnimation:bounce forKey:@"curve"];	
}

-(void)animationDidStop:(CAAnimation *)anim finished:(BOOL)flag
{
	if (flag && endPosition.x < 300 && endPosition.y < 420)
	{
		[self bounceDownStepWithStartingPoint:endPosition andEndPoint:CGPointMake(endPosition.x+30,endPosition.y+30)];
		
	} else {
		[self bounceDownStepWithStartingPoint:CGPointMake(0, 0) andEndPoint:CGPointMake(30, 60)];
	}
	
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
	if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
	    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
	} else {
	    return YES;
	}
}

@end
